#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t, n, k;
    cin>>t>>n>>k;
    vector <int> niz(n);
    bool test=true;
    for (int i=0; i<n; i++)
    {
        cin>>niz[i];
        if (niz[i]!=i+1) test=false;
    }
    if (test)
    {
        int ans=0;
        for (int i=1; i<=n; i++)
        {
            if (i%2!=0)
            {
                if (ans<=i) ans++;
                else ans--;
            }
            else
            {
                if (ans<=n-i+1) ans++;
                else ans--;
            }
        }
        if (ans==k)
        {
            cout<<"DA"<<endl;
            for (int i=1; i<=n; i++)
            {
                if (i%2!=0) cout<<i<<" ";
                else cout<<n-i+1<<" ";
            }
            cout<<endl;
        }
        else cout<<"NE"<<endl;
    }
    else
    {
        sort (niz.begin(), niz.end());
        int ans=0;
        for (int i=0; i<n; i++)
        {
            if (niz[i]>=ans) ans++;
            else ans--;
        }
        if (ans==k)
        {
            cout<<"DA"<<endl;
            for (int i=0; i<n; i++) cout<<niz[i]<<" ";
            cout<<endl;
        }
        else cout<<"NE"<<endl;
    }
    return 0;
}